TUTORIAL DE SUPERCOLLIDER 3 - PARTE 3
Rodrigo F. Cadiz, basado en apuntes de Gary S. Kendall
Northwestern University

(
	Server.default = Server.internal;
	s = Server.default;
	s.boot;
)

Unidades generadoras (UGen)
- Objetos que procesan o generan sonidos
- Pueden tener muchas entradas, pero una sola salida
- Canales multiples se pueden hacer mediante arreglos de unidades generadoras
 
Creacion, tasa de audio, tasa de control
- Se crean a traves de los mensajes ar o kr

FSinOsc.ar(800, 0.0, 0.2); // crear un oscilador sinusoidal a 800 Hz, fase 0.0, amplitud 0.2

Argumentos
- Pueden ser otras UGen, escalares (numeros) o arreglos de UGen o escalares
- Por convencion, los ultimos dos argumentos de la mayoria de las UGen son mul (multiplicador) y add (suma)
- Valores por defecto de mul=1.0 y add=0.0
- Usar mul y add es mas eficiente que escribir expresiones con multiplicaciones y adiciones

Notacion funcional

	{ SinOsc.ar(440, 0, 0.2) }.play;

- Objeto se espefica entre { y } y se llama al metodo play
- Como no se especifica servidor, se usa el por defecto (variable "s"). 
- Tampoco se almaceno nada en una variable, por lo que no se puede reusar.

(
	{ 				// Abrir la funcion
		SinOsc.ar(	// Crear un objeto SinOsc a tasa de audio
			440, 	// frecuencia de 440 Hz, LA
			0, 		// fase inicial 0
			0.2) 	// mul (amplitud) of 0.2
	}.play;			// cerrar la funcion y llamar 'play' sobre ella
)
	
Otro ejemplo,

(
	{ var ampOsc;		// Abrir la funcion y declarar una variable
		ampOsc = SinOsc.kr(0.5, 1.5pi, 0.5, 0.5);	// Crear un objeto SinOsc a tasa de control
					// asignar su resultado a una variable
		SinOsc.ar(440, 0, ampOsc);	// crear un objecto SinOsc a tasa de audio
					// y usar la variable para controlar amplitud
	}.play;
)


Conceptos basicos de osciladores
 
Forma mas facil de generar sonido

	{ SinOsc.ar(800, 0, 0.1) }.play;

Que pasa en caso de errores

	{ SinOsc.ar(800, 0, 0.1) },.play;

Ejemplo de ruido browniano:

	{ BrownNoise.ar(0.1) }.play;

Server, BrownNoise y SinOsc son objetos

play, y ar son mensajes 

800, 0, y 0.1 son literales


Ejemplo con aliasion (alasing o foldover)

{ SinOsc.ar(Line.kr(1,43000,6), 0, 0.1) }.play;


Frecuencia lineal versus tono (pitch)

Line crea una interpolacion lineal entre dos puntos
XLine crea una interpolacion exponenial, usualmente usada para frecuencia
	
ar es tasa de audio
kr es tasa de control

{ SinOsc.ar(Line.kr(400,4000,5), 0, 0.3) }.play;  // Suena como una curva

{ SinOsc.ar(XLine.kr(400,4000,5), 0, 0.3) }.play;  //  Suena lineal


freq, phase, mul, and add are the names of arguments

Otros ejemplos:

	{ SinOsc.ar(freq: 440, phase: 0, mul: 0.4, add: 0) }.play;

	{ SinOsc.ar(phase: 0, freq: 440, add: 0, mul: 0.4) }.play;

	{ SinOsc.ar(freq: 440, mul: 0.4) }.play;

freq:440 es un ejemplo de argumento clave


SC tiene muchos otros objetos que son osciladores:

Por ejemplo:
	SinOsc		FSinOsc		Osc			Buffer	OscN
	
Tambien son utiles:	
	Impulse		Blip			Pulse		LFPulse
	Saw			LFSaw	
	Klang		Formant	
	VOsc		VOsc3
	
Algunos un poco mas complicados:
	SyncSaw	VarSaw
	LFPar		LFCub	
	Gendy1		Gendy2		Gendy3	
	
	
	